aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorChengguang Xu <cgxu519@icloud.com>2017-12-15 15:47:35 +0800
committerEryu Guan <eguan@redhat.com>2017-12-24 21:30:58 +0800
commit0f2373e045cf4b84599f99ed7a17f96461d35b1b (patch)
tree984bbc276b18b27bae38f07aaac3b37104e41071
parentc3594bec4e7f025d6f096c4dad6467d64e4e596b (diff)
downloadxfstests-0f2373e045cf4b84599f99ed7a17f96461d35b1b.tar.gz
generic: add syncfs test
Inspired by syncfs bug of overlayfs which does not sync dirtyinodes in underlying filesystem. Run syncfs and shutdown filesystem(or underlying filesystem of overlayfs) to check syncfs result. Signed-off-by: Chengguang Xu <cgxu519@icloud.com> Reviewed-by: Amir Goldstein <amir73il@gmail.com> Signed-off-by: Eryu Guan <eguan@redhat.com>
-rwxr-xr-xtests/generic/47484
-rw-r--r--tests/generic/474.out2
-rw-r--r--tests/generic/group1
3 files changed, 87 insertions, 0 deletions
diff --git a/tests/generic/474 b/tests/generic/474
new file mode 100755
index 0000000000..39a1bd687d
--- /dev/null
+++ b/tests/generic/474
@@ -0,0 +1,84 @@
+#! /bin/bash
+# FS QA Test 474
+#
+# Inspired by syncfs bug of overlayfs which does not sync dirty inodes in
+# underlying filesystem.
+#
+# Create a small file then run syncfs and shutdown filesystem(or underlying
+# filesystem of overlayfs) to check syncfs result.
+#
+# Test will be skipped if filesystem(or underlying filesystem of overlayfs)
+# does not support shutdown.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2017 Chengguang Xu <cgxu519@icloud.com>
+# All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=0
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+_supported_fs generic
+_supported_os Linux
+_require_fssum
+_require_scratch
+_require_scratch_shutdown
+_require_xfs_io_command "syncfs"
+
+_scratch_mkfs >/dev/null 2>&1
+_scratch_mount
+
+# Background writeback will flush dirty inode by dirty ratio and dirty time
+# period(default 30 seconds), in order to avoid interference from it,
+# run sync before test to make all dirty inodes clean, and it also
+# accelerates syncfs on testing filesystem so that test case can finish
+# in 30 seconds.
+
+sync
+
+$XFS_IO_PROG -f -c "pwrite 0 4K" $SCRATCH_MNT/testfile >/dev/null 2>&1
+
+# fssum used for comparing checksum of test file(data & metedata),
+# exclude checking about atime, block structure, open error.
+$FSSUM_PROG -ugomAcdES -f -w $tmp.fssum $SCRATCH_MNT
+$XFS_IO_PROG -c "syncfs" $SCRATCH_MNT/testfile >/dev/null 2>&1
+_scratch_shutdown
+_scratch_cycle_mount
+$FSSUM_PROG -r $tmp.fssum $SCRATCH_MNT
+
+exit
diff --git a/tests/generic/474.out b/tests/generic/474.out
new file mode 100644
index 0000000000..c43c74f36a
--- /dev/null
+++ b/tests/generic/474.out
@@ -0,0 +1,2 @@
+QA output created by 474
+OK
diff --git a/tests/generic/group b/tests/generic/group
index b6e90a00e9..d2d0b53b10 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -476,3 +476,4 @@
471 auto quick rw
472 auto quick rw
473 auto quick
+474 auto quick shutdown metadata